from PIL import Image

#Generer l'objet, voir les premières metadonnées
                                       
im = Image.open('D:/Cours/lycee/snt/image/photocouleur.jpg') 
print(im)  #permet de voir les métadonnées les plus importantes


#voir les valeurs des pixels en ligne

print( im.getpixel((0,0)) ) #on peut voir LE pixel en haut à gauche

data = list(im.getdata())
print(data)  #c'est un peu long, mais moins qu'un conseil pédagogique ;-)
#on voit des triplets de nombres car notre image est en RGB


#pour convertir en niveau de gris
img=im.convert('L')
print( img.getpixel((0,0)) )   #on peut voir LE pixel en haut à gauche
print(img) #on peut voir qu'elle est en mode L

img.save('D:/Cours/lycee/snt/image/photogris.bmp')  #on "cree" le fichier image correspondant à ces données



#pour voir plus de métadonnées

from PIL import Image, ExifTags
im = Image.open("D:/Cours/lycee/snt/image/photocouleur.jpg")
exif = im._getexif()

print(exif)

#pour n'afficher que la métadonnée des coordonnées GPS
print(exif[34853])


#Version sans tableaux numpy
from PIL import Image #si pas fait avant
img = Image.open('D:/Cours/lycee/snt/image/photosceauxgris.bmp') #si pas fait avant
print(img.size)  #la largeur=nb de colonne est en premier

for i in range(640):  #je pense plus accessible de mettre des valeurs numeriques,
    for j in range(480):   #quitte a ce que l'eleve les modifie ensuite s'il change d'image
    
        x = img.getpixel( (i,j) )  #ancienne valeur du pixel issue de im
        
        #a modifier selon le tp
        y = x*x/255  #exemple fonction carree ramenee à l'intervalle [0;255]
        
        img.putpixel( (i,j) , y) #nouvelle valeur du pixel dans im
        
img.save('D:/Cours/lycee/snt/image/photosceauxgrismodifiee.bmp')
#attention a changer le nom de l'image obtenue

#Version couleur sans tableaux numpy
from PIL import Image #si pas fait avant
im = Image.open('D:/Cours/lycee/snt/image/photosceaux.jpg') #si pas fait avant
print(im.size)  #la largeur=nb de colonne est en premier
im2 = Image.new('L', im.size, 255) #on cree une image en mode L de meme dimension que im toute blanche

for i in range(640):  
    for j in range(480):   
    
        R,V,B = im.getpixel( (i,j) )  #ancienne valeur du pixel issue de im
        
        #a modifier selon le tp
        
        
        im2.putpixel( (i,j) , y) #nouvelle valeur du pixel dans im2
        
im2.save('D:/Cours/lycee/snt/image/photosceauxconvertieengris.bmp')
#attention a changer le nom de l'image obtenue


#version avec Numpy

# fonctions pour obtenir la matrice (tableau numpy) d'une image  ou  l'image d'une matrice (tableau numpy)
import numpy   # Pour manipuler des tableaux de nombres
def OuvrirImgGris(chemin):
    im = Image.open(str(chemin))   #crée un objet im qui contient l'image située à l'adresse indiquée
    largeur,hauteur = im.size   #méthode size récupère les dimensions
    imdata=im.getdata()  #la methode getdata permet de récuperer les valeurs des pixels en liste
    tab=numpy.array(imdata)  #met les données en tableau
    matrix = numpy.reshape(tab,(hauteur,largeur))  #met les données sous forme de matrice
    return matrix

def CreerImgGris(matrix,path): #matrice de l'image à reconstruire, plus chemin de sortie.
    size=(matrix.shape[1],matrix.shape[0]) #entre matrice et image l'ordre des dimensions est inversé
    im2 = Image.new("L",size)
    im2.putdata(list(matrix.flat))
    im2.save(fp=str(path))

#main

matrice1=OuvrirImgGris('D:/Cours/lycee/snt/image/photosceauxgris.bmp')
print (matrice1)  #on voit la forme matricielle
matrice2=matrice1.copy  #il est préférable de modifier une copie
print(matrice1.shape)  #la hauteur=nb de ligne est en premier

for i in range(480):  #je pense plus accessible de mettre des valeurs numeriques,
    for j in range(640):   #quitte a ce que l'eleve les modifie ensuite s'il change d'image
    
        x = matrice1[i][j]  #ancienne valeur du pixel issue de matrice1
        
        #a modifier selon le tp
        y = x*x/255  #exemple fonction carree ramenee à l'intervalle [0;255]
        
        matrice2[i][j] = y #nouvelle valeur du pixel dans matrice2
        
CreerImgGris(matrice2,'D:/Cours/lycee/snt/image/photosceauxgrismodifiee.bmp')
#attention a changer le nom de l'image obtenue
